//  
//  SoftBank X}[gtHT[rXJxTCg
//  t@XR[h10(F)
//
//  Copyright(c) 2011 SOFTBANK MOBILE Corp. All rights reserved
//

package com.example.speechrecognitionsample;

import java.util.ArrayList;

import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

public class SpeechRecognitionSample extends Activity implements
		View.OnClickListener {
	private final static int REQUEST_CODE = 0;
	private EditText editText;

	@Override
	public void onCreate(Bundle bundle) {
		// FJnButton
		// ʂ\EditTextݒu܂
		super.onCreate(bundle);
		LinearLayout layout = new LinearLayout(this);
		layout.setOrientation(LinearLayout.VERTICAL);
		setContentView(layout);
		editText = new EditText(this);
		layout.addView(editText);
		layout.addView(getButton("Speech Recognition", "w"));

	}

	// {^
	private Button getButton(String text, String tag) {
		Button button = new Button(this);
		button.setText(text);
		button.setTag(tag);
		button.setOnClickListener(this);
		return button;
	}

	@Override
	public void onClick(View v) {
		// {^ꂽCegJڂFJn܂
		try {
			// FCeg쐬܂
			Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
			// ͂̌`w肵܂
			// LANGUAGE_MODEL_FREE_FORM:RȌ`ł
			// LANGUAGE_MODEL_WEB_SEARCH:pɍ킹܂
			intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,
					RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
			// ŕ\bZ[Ww肵܂
			intent.putExtra(RecognizerIntent.EXTRA_PROMPT,
					"SpeechRecognitionSample");
			// onActivityResult()ĂяoAANeBreB̌ʂ߂܂
			startActivityForResult(intent, REQUEST_CODE);
		} catch (ActivityNotFoundException e) {
			editText.setText(e.getMessage());
		}
	}

	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// F̌ʂ擾܂
		if (requestCode == REQUEST_CODE && resultCode == RESULT_OK) {
			// ʂ𕶎zƂĎ擾܂
			String str = "";
			ArrayList<String> results = data
					.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);

			// ł͎擾ꂽ̌SČAEditTextŕ\܂
			for (int i = 0; i < results.size(); i++) {
				str += results.get(i) + " ";
			}
			editText.setText(str);
		}
	}

}
